package JavaProject.Gui;
import javax.swing.*;
import java.awt.*;

public class ADisplay extends JPanel{
    /*******************************************************************
     * This is the panel that displays answer options to the user.  It *
     * features a CardLayout so that it can be switched for either     *
     * multiple choice or user input questions as needed by using the  *
     * setMode() method.                                               *
     *******************************************************************/
    
    
    private int mode = 0;
    private JPanel multPanel, inpPanel, defPanel;
    private JCheckBox chk1, chk2, chk3, chk4;
    private JLabel ans1, ans2, ans3, ans4, ans5, filler;
    private JTextField tf;
    private JScrollPane scrollpane;
    private JLabel[] ansz;
    
    public ADisplay(){
        setupComponents();
        setupMultPanel();
        setupInpPanel();
        setupDefPanel();
        addComponents();
        setMode("default");
    }
    
    private void setupComponents(){
        multPanel = new JPanel();
        inpPanel = new JPanel();
        defPanel = new JPanel();
        chk1 = new JCheckBox();
        chk2 = new JCheckBox();
        chk3 = new JCheckBox();
        chk4 = new JCheckBox();
        ans1 = new JLabel();
        ans2 = new JLabel();
        ans3 = new JLabel();
        ans4 = new JLabel();
        ans5 = new JLabel("Please enter your answer below, then press Next");
        filler = new JLabel(" ");
        tf = new JTextField(50);
        scrollpane = new JScrollPane(multPanel);
        scrollpane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
        ansz = new JLabel[4];
        ansz[0] = ans1; ansz[1] = ans2; ansz[2] = ans3; ansz[3] = ans4;
    }

    private void setupMultPanel(){
        multPanel.setLayout(new GridBagLayout());
        JPanel p = multPanel;
        addTool.add(p, chk1, 0, 0, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
        addTool.add(p, chk2, 0, 1, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
        addTool.add(p, chk3, 0, 2, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
        addTool.add(p, chk4, 0, 3, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
        addTool.add(p, ans1, 1, 0, 4, 1, 0.2, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(p, ans2, 1, 1, 4, 1, 0.2, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(p, ans3, 1, 2, 4, 1, 0.2, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(p, ans4, 1, 3, 4, 1, 0.2, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(p, filler, 0, 4, 5, 1, 0.5, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
    }
        
    private void setupInpPanel(){
        inpPanel.setLayout(new GridBagLayout());
        JPanel p = inpPanel;
        addTool.add(p, filler, 0, 0, 5, 1, 0.5, 0.2, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
        addTool.add(p, ans5, 1, 1, 4, 1, 0.5, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
        addTool.add(p, tf, 1, 2, 4, 1, 0.5, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
        addTool.add(p, filler, 0, 3, 5, 1, 0.5, 0.2, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
        addTool.add(p, filler, 0, 4, 5, 1, 0.5, 0.2, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
    }
    
    private void setupDefPanel(){
        defPanel.setLayout(new GridBagLayout());
        JPanel p = defPanel;
        addTool.add(p, filler, 0, 0, 5, 1, 0.5, 0.5, 0, 0, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
        addTool.add(p, filler, 0, 1, 5, 1, 0.5, 0.5, 0, 0, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
        addTool.add(p, filler, 0, 2, 5, 1, 0.5, 0.5, 0, 0, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
        addTool.add(p, filler, 0, 3, 5, 1, 0.5, 0.5, 0, 0, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
        addTool.add(p, filler, 0, 4, 5, 1, 0.5, 0.5, 0, 0, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
    }
    
    public void addComponents(){
        setLayout(new CardLayout());
        add(defPanel, "default");
        add(multPanel, "multi");
        add(inpPanel, "input");
    }
    
    public void setMode(String i){
        CardLayout cl = (CardLayout)getLayout();
        cl.show(this, i);
    }
    
    public void setMultAnswers(String[] atext){
        for(int i = 0; i < 4; i++){
            ansz[i].setText(atext[i]);
        }
    }
    
    public void clearMultAnswers(){
        for (int i = 0; i < 4; i++){
            ansz[i].setText(" ");
        }
    }
    
    public boolean[] getMultAnswer(){
        boolean[] temp = new boolean[4];
        temp[0] = chk1.isSelected();
        temp[1] = chk2.isSelected();
        temp[2] = chk3.isSelected();
        temp[3] = chk4.isSelected();
        chk1.setSelected(false);
        chk2.setSelected(false);
        chk3.setSelected(false);
        chk4.setSelected(false);
        return temp;
    }
    
    public String getInpAnswer(){
        String s = tf.getText();
        return s;
    }
    
    public void clearInpAnswer(){
        tf.setText("");
    }

}