package JavaProject.Gui;
import javax.swing.*;
import javax.swing.text.*;
import java.awt.*;

public class QDisplay extends JPanel{
    /***************************************************************
     * This is where the text of a Question will be displayed.  It *
     * also displays the clock, the question count, and an         *
     * underutilized System display.                               *
     ***************************************************************/
    
    private JTextPane ta;
    private JScrollPane scrollpane;
    private JLabel qLabel, sysLabel, timeLabel;
    
    public QDisplay(){
        setLayout(new GridBagLayout());
        setupComponents();
        addComponents();
    }
    
    public void setupComponents(){
        ta = new JTextPane(new DefaultStyledDocument());
        scrollpane = new JScrollPane(ta);
        scrollpane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        scrollpane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        qLabel = new JLabel("00 of 00");
        sysLabel = new JLabel(" ");
        timeLabel = new JLabel("00:00");
        qLabel.setBorder(BorderFactory.createEtchedBorder());
        sysLabel.setBorder(BorderFactory.createEtchedBorder());
        timeLabel.setBorder(BorderFactory.createEtchedBorder());
    }
    
    public void addComponents(){
        JPanel p = this;
        addTool.add(p, scrollpane, 0, 0, 5, 4, 0.5, 0.5, 0, 0, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
        addTool.add(p, qLabel, 0, 4, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
        addTool.add(p, sysLabel, 1, 4, 1, 3, 0.5, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
        addTool.add(p, timeLabel, 4, 4, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
    }
    
    public JPanel getQDisplay(){return this;}
    public JLabel getTimeLabel(){return timeLabel;}
    public JLabel getQLabel(){return qLabel;}
    
    public void setQText(String text){
        ta.setText(text);
        ta.setCaretPosition(0);
    }
    
    public void clearQText(){
        ta.setText("");
    }
    
    public void setSysText(String message){
        sysLabel.setText(message);
    }
}