package JavaProject.Gui;
import java.awt.*;
import javax.swing.*;
import javax.swing.text.*;

public class answerLogDisplay extends JPanel{
    
    /************************************************************
     * This JPanel is used for displaying the results of a test *
     * and provides an alternative location for displaying      *
     * error messages, since JDialog was impractical (main Gui  *
     * is a JPanel, not a JFrame).                              *
     ************************************************************/
    
    private JTextPane ta;
    private JScrollPane scrollpane;
    private JButton newButton, quitButton;
    
    public answerLogDisplay(){
        setupComponents();
        setLayout(new GridBagLayout());
        addTool.add(this, scrollpane, 0, 0, 8, 5, 0.5, 0.5, 0, 0, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
        addTool.add(this, newButton, 7, 5, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
        addTool.add(this, quitButton, 0, 5, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
    }
    
    public void setupComponents(){
        ta = new JTextPane(new DefaultStyledDocument());
        scrollpane = new JScrollPane(ta);
        scrollpane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        scrollpane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        newButton = new JButton("New Test");
        quitButton = new JButton("Quit");
    }
    
    public void setResults(String results){ta.setText(results); ta.setCaretPosition(0);}    
    public void clearResults(){ta.setText("");}
    public JButton[] getButtons(){return new JButton[]{newButton, quitButton};}
    public void hideQuitButton(boolean web){quitButton.setVisible(web);}
}