package JavaProject.Gui;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import JavaProject.Test.*;

public class appGui extends JPanel implements ActionListener{
    
    /****************************************************************
     * This panel is the master Gui for the application.  It can be *
     * included in a frame to run as a standalone or used by a web  *
     * applet.  All other panels are access through this one.       *
     ****************************************************************/
    
    private QDisplay qDisplay;
    private ADisplay aDisplay;
    private controlDisplay ctrlDisplay;
    private answerLogDisplay logDisplay;
    private setupDisplay setup;
    private JPanel tester;
    private String opt1 = "0";
    private appGui toGo = this;
    private JTabbedPane pane;
    
    public appGui(){
        setupComponents();
        addComponents();
        pane = new JTabbedPane();
        pane.addTab("Setup", setup);
        pane.addTab("Test", tester);
        pane.addTab("Results", logDisplay);
        setLayout(new GridLayout(1,1));
        add(pane);
        JButton okButton = setup.getOKButton();
        okButton.setActionCommand(opt1);
        okButton.addActionListener(this);
        pane.setEnabledAt(1, false);
        pane.setEnabledAt(2, false);
    }
    
    public appGui(boolean web){//used for applets, hides the quitbuttons
        this();
        ctrlDisplay.hideQuitButton(web);
        logDisplay.hideQuitButton(web);
    }
    
    public void setupComponents(){
        qDisplay = new QDisplay();
        aDisplay = new ADisplay();
        ctrlDisplay = new controlDisplay();
        logDisplay = new answerLogDisplay();
        setup = new setupDisplay();
        tester = new JPanel();
    }
    
    public void addComponents(){
        tester.setLayout(new GridBagLayout());
        addTool.add(tester, qDisplay, 0, 0, 5, 5, 0.5, 0.95, 0, 0, GridBagConstraints.BOTH, GridBagConstraints.NORTH);
        addTool.add(tester, aDisplay, 0, 5, 5, 5, 0.5, 0.2, 0, 0, GridBagConstraints.BOTH, GridBagConstraints.NORTH);
        addTool.add(tester, ctrlDisplay, 0, 10, 5, 1, 0.5, 0, 0, 0, GridBagConstraints.BOTH, GridBagConstraints.NORTH);
    }
    
    public void hideTab(int index, boolean on, int nextIndex){ //convenience method
        pane.setSelectedIndex(nextIndex);
        pane.setEnabledAt(index, on);
        if (!pane.isEnabledAt(nextIndex))
            pane.setEnabledAt(nextIndex, true);
        }
    
    public ADisplay getADisplay(){return aDisplay;}
    public QDisplay getQDisplay(){return qDisplay;}
    public answerLogDisplay getLogDisplay(){return logDisplay;}
    public controlDisplay getControlDisplay(){return ctrlDisplay;}
        
    public void actionPerformed(ActionEvent e){
        switch(Integer.parseInt(e.getActionCommand())){
            case 0: /* Switch is unnecessary, implemented because of
                     * force of habit and future plans to expand the gui */
                qDisplay.setSysText("Loading data, please wait ...");
                hideTab(0, false, 1);
                startTest();
                break;
        }
    }
    
    public void startTest(){
        User tempUser = setup.gatherData();
        tempUser.setGui(this);
        ctrlDisplay.activate(true);
        Test test = new Test(tempUser);
        test.go();
    }

}