package JavaProject.Gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import JavaProject.Qeditor.*;

public class editGui extends JPanel implements ActionListener{
    
    private JTextArea ta;
    private JTextField ans1, ans2, ans3, ans4;
    private JLabel typeLabel1, typeLabel2, typeLabel3, insLabel, insLabel1;
    private JRadioButton rad1, rad2;
    private ButtonGroup bg;
    private JComboBox diffBox;
    private JButton nextButton, clrButton;
    private JPanel optPanel, chkPanel, lblPanel;
    private JScrollPane scrollpane;
    private JCheckBox chk1, chk2, chk3, chk4;
    private JFileChooser chooser;
    private FileHandler handler;
    private boolean handlerExists;
    private String[] act = {"0", "1", "2"};
    private final String MULT_INSTRUCTIONS = "CHOICE MODE: Enter 4 answers below, check the correct ones";
    private final String INP_INSTRUCTIONS = "INPUT MODE: Enter 4 possible permutations of the correct answer below";
    
    public editGui(){
        setupComponents();
        setActions();
        setupPanels();
        addComponents();
    }
    
    public void setupComponents(){
        ta = new JTextArea();
        scrollpane = new JScrollPane(ta);
        scrollpane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        ans1 = new JTextField(); ans2 = new JTextField(); 
        ans3 = new JTextField(); ans4 = new JTextField();
        typeLabel1 = new JLabel("  Current Question type: ");
        typeLabel2 = new JLabel("Multiple choice  ");
        typeLabel3 = new JLabel("User input");
        insLabel = new JLabel(MULT_INSTRUCTIONS);
        insLabel.setBorder(BorderFactory.createEtchedBorder());
        insLabel1 = new JLabel("Enter or paste the text of your Question below");
        insLabel1.setBorder(BorderFactory.createEtchedBorder());
        rad1 = new JRadioButton("", true);
        rad2 = new JRadioButton();
        bg = new ButtonGroup();
        bg.add(rad1); bg.add(rad2);
        String[] difficulty = {"Easy", "Medium", "Hard"};
        diffBox = new JComboBox(difficulty);
        nextButton = new JButton(" Next ");
        clrButton = new JButton("Clear");
        optPanel = new JPanel();
        chkPanel = new JPanel();
        lblPanel = new JPanel();
        chk1 = new JCheckBox(); chk2 = new JCheckBox();
        chk3 = new JCheckBox(); chk4 = new JCheckBox();
        handlerExists = false;
        chooser = new JFileChooser();
    }
    
    public void setActions(){
        rad1.setActionCommand(act[0]);
        rad2.setActionCommand(act[1]);
        clrButton.setActionCommand(act[2]);
        rad1.addActionListener(this);
        rad2.addActionListener(this);
        clrButton.addActionListener(this);
    }   
    
    public void setupPanels(){
        chkPanel.setLayout(new GridLayout(4,1));
        chkPanel.add(chk1); chkPanel.add(chk2);
        chkPanel.add(chk3); chkPanel.add(chk4);
        optPanel.setLayout(new CardLayout());
        optPanel.add("multi", chkPanel);
        optPanel.add("input", lblPanel);
    }
    
    public void addComponents(){
        JPanel p = this;
        p.setLayout(new GridBagLayout());
        addTool.add(p, typeLabel1, 0, 0, 3, 1, 0.1, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(p, rad1, 3, 0, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.CENTER);
        addTool.add(p, rad2, 6, 0, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.CENTER);
        addTool.add(p, typeLabel2, 4, 0, 2, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.CENTER);
        addTool.add(p, typeLabel3, 7, 0, 2, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
        addTool.add(p, insLabel1, 0, 1, 9, 1, 0.8, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
        addTool.add(p, scrollpane, 0, 2, 9, 2, 0.4, 0.8, 0, 0, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
        addTool.add(p, insLabel, 0, 4, 9, 1, 0.8, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
        addTool.add(p, optPanel, 0, 5, 1, 4, 0, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(p, ans1, 1, 5, 8, 1, 0.3, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(p, ans2, 1, 6, 8, 1, 0.3, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(p, ans3, 1, 7, 8, 1, 0.3, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(p, ans4, 1, 8, 8, 1, 0.3, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(p, diffBox, 0, 9, 2, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
        addTool.add(p, clrButton, 7, 9, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
        addTool.add(p, nextButton, 8, 9, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
    }
    
    private void setMode(String instruction, String panel){
        insLabel.setText(instruction);
        CardLayout c = (CardLayout)optPanel.getLayout();
        c.show(optPanel, panel);
    }
    
    private void clearAll(){
        ta.setText("");
        ans1.setText(""); ans2.setText(""); ans3.setText(""); ans4.setText("");
        chk1.setSelected(false); chk2.setSelected(false);
        chk3.setSelected(false); chk4.setSelected(false);
    }
    
    private String checkString(String s){
        /* This is silly but prevents errors with the QLoader in the event 
         * of blank answers in a User Input question.  It is never displayed
         * so it's never an issue.*/
        if (s.length() < 1){return "<missing data>";}
        return s;
    }
    
    public String gatherData(){
        int skill = diffBox.getSelectedIndex();
        if(rad2.isSelected()){skill+=3;}
        String temp = skill + "#" + ta.getText() + "#" +
            checkString(ans1.getText()) + "#" + chk1.isSelected() + "#" + 
            checkString(ans2.getText()) + "#" + chk2.isSelected() + "#" + 
            checkString(ans3.getText()) + "#" + chk3.isSelected() + "#" + 
            checkString(ans4.getText()) + "#" + chk4.isSelected() + "#";
        clearAll();
        return temp;
    }
    
    public JButton getNextButton(){return nextButton;}
    
    public static void main(String args[]){
        JFrame f = new JFrame();
        f.getContentPane().add(new editGui());
        f.setSize(450, 320);
        f.setVisible(true);
        f.addWindowListener(new WindowAdapter(){
            public void windowClosing(WindowEvent e) {System.exit(0);}
        });
    }
    
    public void actionPerformed(ActionEvent e){
        switch(Integer.parseInt(e.getActionCommand())){
            case 0:
                setMode(MULT_INSTRUCTIONS, "multi");
                break;
            case 1:
                setMode(INP_INSTRUCTIONS, "input");
                break;
            case 2:
                clearAll();
                break;
        }
    }
}