package JavaProject.Gui;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import JavaProject.Test.User;

public class setupDisplay extends JPanel implements ActionListener{
    
    /*********************************************************************
     * This panel is where a user will enter it's details and select the *
     * database of questions it wishes to use.                           *
     *********************************************************************/

    private JLabel defLabel, loadLabel, SQLLabel, URLLabel, userLabel, passLabel;
    private JTextField nameField, URLField, userField, dirField;
    private JPasswordField passField;
    private JButton okButton, loadButton;
    private JRadioButton rad1, rad2, rad3;
    private ButtonGroup bg;
    private JComboBox skillLevel, numOfQuestions, ansOption;
    private String opt1 = "0";
    private String opt2 = "1";
    private String opt3 = "2";
    private String loadOpt = "3";
    private File dataFile;
    private JFileChooser fc;
    
    public setupDisplay(){
        setupComponents();
        addComponents();
    }
    
    private void setupComponents(){
        defLabel = new JLabel("Use the default Question database", Label.LEFT);
        loadLabel = new JLabel("Load a text database  ", Label.LEFT);
        SQLLabel = new JLabel("Connect to a mySQL database", Label.LEFT);
        URLLabel = new JLabel("Database URL: ", Label.LEFT);
        userLabel = new JLabel("User Name: ", Label.LEFT);
        passLabel = new JLabel("Password: ", Label.LEFT);
        nameField = new JTextField();
        URLField = new JTextField("jdbc:mysql://<HOST>:<PORT>/<DB>");
        userField = new JTextField();
        passField = new JPasswordField();
        dirField = new JTextField();
        fc = new JFileChooser();
        String[] level = {"Neanderthal", "Joe Average", "Boffin"};
        String[] qz = {"Ten", "Twenty", "Thirty"};
        String[] anz = {"When I'm done", "No"};
        skillLevel = new JComboBox(level);
        numOfQuestions = new JComboBox(qz);
        ansOption = new JComboBox(anz);
        okButton = new JButton("   OK   ");
        loadButton = new JButton("Load");
        loadButton.setActionCommand(loadOpt);
        loadButton.addActionListener(this);
        rad1 = new JRadioButton("", true);
        rad1.setActionCommand(opt1);
        rad1.addActionListener(this);
        rad2 = new JRadioButton();
        rad2.setActionCommand(opt2);
        rad2.addActionListener(this);
        rad3 = new JRadioButton();
        rad3.setActionCommand(opt3);
        rad3.addActionListener(this);
        bg = new ButtonGroup();
        bg.add(rad1);
        bg.add(rad2);
        bg.add(rad3);
        setOpt(true, false, false);
    }
    
    public void addComponents(){
        JPanel c = this;
        c.setLayout(new GridBagLayout());
        addTool.add(c, new JLabel("Enter your name ", Label.RIGHT), 0, 0, 2, 1, 0, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.EAST);
        addTool.add(c, new JLabel("Select skill", Label.RIGHT), 0, 1, 2, 1, 0, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.EAST);
        addTool.add(c, new JLabel("How many questions?", Label.RIGHT), 0, 2, 2, 1, 0, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.EAST);
        addTool.add(c, new JLabel("View answers?", Label.RIGHT), 0, 3, 2, 1, 0, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.EAST);
        addTool.add(c, defLabel, 1, 4, 3, 1, 0.1, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
        addTool.add(c, loadLabel, 1, 5, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
        addTool.add(c, SQLLabel, 1, 6, 3, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
        addTool.add(c, URLLabel, 1, 7, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
        addTool.add(c, userLabel, 1, 8, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
        addTool.add(c, passLabel, 1, 9, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
        addTool.add(c, nameField, 2, 0, 3, 1, 0.1, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(c, dirField, 2, 5, 2, 1, 0.1, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(c, URLField, 2, 7, 3, 1, 0.1, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(c, userField, 2, 8, 3, 1, 0.1, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(c, passField, 2, 9, 3, 1, 0.1, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(c, rad1, 0, 4, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.CENTER);
        addTool.add(c, rad2, 0, 5, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.CENTER);
        addTool.add(c, rad3, 0, 6, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.CENTER);
        addTool.add(c, skillLevel, 2, 1, 1, 1, 0, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(c, numOfQuestions, 2, 2, 1, 1, 0, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(c, ansOption, 2, 3, 1, 1, 0, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
        addTool.add(c, okButton, 4, 10, 1, 1, 0, 0, 0, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
        addTool.add(c, loadButton, 4, 5, 1, 1, 0, 0, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.EAST);
    }
    
    private void setDef(boolean on){
        defLabel.setEnabled(on);
    }
    
    private void setLoad(boolean on){
        loadLabel.setEnabled(on);
        loadButton.setEnabled(on);
    }
    
    private void setSQL(boolean on){
        SQLLabel.setEnabled(on);
        URLLabel.setEnabled(on);
        userLabel.setEnabled(on);
        passLabel.setEnabled(on);
        URLField.setEnabled(on);
        userField.setEnabled(on);
        passField.setEnabled(on);
    }
    
    private void setOpt(boolean def, boolean loadf, boolean SQLf){
        setDef(def);
        setLoad(loadf);
        setSQL(SQLf);
    }
    
    public JButton getOKButton(){
        return okButton;
    }
    
    public void actionPerformed(ActionEvent e){
        switch(Integer.parseInt(e.getActionCommand())){
            case 0:
                setOpt(true, false, false);
                break;
            case 1:
                setOpt(false, true, false);
                break;
            case 2:
                setOpt(false, false, true);
                break;
            case 3:
                int returnVal = fc.showOpenDialog(this);
                if(returnVal == JFileChooser.APPROVE_OPTION) {
                    dataFile = fc.getSelectedFile();
                } if (dataFile!=null){ 
                    dirField.setText(dataFile.getAbsolutePath());
                }
                break;
        }
    }
    
    public User gatherData(){
        String[] SQLData = new String[4];
        String userName = nameField.getText();
        if (userName.length()<1){userName="You";}
        int skill = skillLevel.getSelectedIndex();
        int i = numOfQuestions.getSelectedIndex();
        int numQz = ++i * 10;
        boolean ansz = true;
        if (ansOption.getSelectedIndex() == 1){ansz = false;}            
        if (dataFile == null) {dataFile = new File("default");}
        if (rad3.isSelected()){
            SQLData[0] = URLField.getText();
            SQLData[1] = userField.getText();
            SQLData[2] = new String(passField.getPassword());
            SQLData[3] = "1";
        } else {
            SQLData[0] = "";
            SQLData[1] = "";
            SQLData[2] = "";
            SQLData[3] = "0";
        }
        User tempUser = User.getUser();   
        tempUser.setValues(userName, skill, numQz, ansz, dataFile, SQLData);
        return tempUser;
    }
}