package JavaProject.Qeditor;

public class InpAnswerChecker{
    
    /******************************************************************
     * This class tests if a user's typed input is a valid anwer or   *
     * not.  To avoid complications, the whitespace is first stripped *
     * out.  The users answer then gets checked against all four      *
     * possible answers.  Only one match is needed to return true.    *
     ******************************************************************/
    
    private String[] answers;
    private String userAnswer;
    
    public InpAnswerChecker(String[] answers, String userAnswer){
        this.answers = answers;
        this.userAnswer = strip(userAnswer);
    }
    
    public boolean result(){
        for (int i = 0; i < 4; i++){
            String chkAnswer = strip(answers[i]);
            if(chkAnswer.length() < (userAnswer.length()+1)){
                if(compare(chkAnswer, userAnswer)){
                    return true;
                }
            }
        }
        return false;
    }
    
    public boolean compare(String a, String b){
        for (int i = 0; i < a.length(); i++){
            if ((a.charAt(i)) != (b.charAt(i))){
                return false;
            }    
        }return true;
    }
    
    public String strip(String s){
        StringBuffer temp = new StringBuffer();
        for(int i = 0; i < s.length(); i++){
            char c = s.charAt(i);
            if (c!=' '){
                temp.append(c);
            }
        }
        return temp.toString();
    }
}