package JavaProject;
import JavaProject.Gui.editGui;
import JavaProject.Qeditor.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class QuestionEditor extends JFrame implements ActionListener{
    
    /**********************************************************************
     * The editor I used to set up the default database is included here  *
     * in case you want to make your own databases.  It's not technically *
     * part of the project so you can't mark me down for it :)            *
     **********************************************************************/
    
    private editGui Gui;
    private FileHandler handler;
    private boolean handlerExists = false;
    private JFileChooser chooser;
    private JMenuBar mb;
    private JMenu options;
    private JMenuItem file, quit;
    private JButton nextButton;
    private String[] act = {"0", "1", "2"};
    
    public static void main(String args[]){
        try{
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e){}
        QuestionEditor qe = new QuestionEditor();
    }

    public QuestionEditor(){
        setupComponents();
        setupListeners();
    }
    
    public void setupComponents(){
        Container f = getContentPane();
        Gui = new editGui();
        f.add(Gui);
        nextButton = Gui.getNextButton();
        mb = new JMenuBar();
        options = new JMenu("Options");
        file = new JMenuItem("File...");
        quit = new JMenuItem("Quit");
        chooser = new JFileChooser();
        chooser.setDialogTitle("Enter new filename or choose text database to append");
        options.add(file);
        options.addSeparator();
        options.add(quit);
        mb.add(options);
        setSize(450, 320);
        setJMenuBar(mb);
        setTitle("jQEdit v1.2");
        setVisible(true);
    }
    
    public void setupListeners(){
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {System.exit(0);}
        });
        file.setActionCommand(act[0]);
        quit.setActionCommand(act[1]);
        nextButton.setActionCommand(act[2]);
        file.addActionListener(this);
        quit.addActionListener(this);
        nextButton.addActionListener(this);
    }
    
    private void fileSelect(){
        int selection = chooser.showDialog(this, "Select");
        if (selection == JFileChooser.APPROVE_OPTION){
            handler = new FileHandler(chooser.getSelectedFile());
            handlerExists = true;
        } else {handlerExists = false;}
    }

    
    public void actionPerformed(ActionEvent e){
        switch(Integer.parseInt(e.getActionCommand())){
            case 0:
                fileSelect();
                break;
            case 1:
                System.exit(0);
                break;
            case 2:
                if(!handlerExists){fileSelect();};
                if(handlerExists){ //seems silly but avoids errors if "cancel" is pressed in FileChooser
                    handler.writeLine(Gui.gatherData());
                }
                break;
        }

    }
}
    