package JavaProject.Test;

import JavaProject.Qeditor.*;
import JavaProject.Gui.appGui;
import java.io.File;
import javax.swing.JButton;
import java.awt.event.*;


public class Test implements ActionListener{
    
    /**********************************************************************
     * This class handles Thread control for the two major aspects of the *
     * TestSimulator - the clock and the actual answering process.        *
     **********************************************************************/
    
    private User user;
    private int time;
    private appGui frame;
    private Qloader loader;
    private boolean ok;
    private JButton[] buttons;
    
    public Test(User user){
        this.user = user;
        if (user.getFileMode()==1){
            //System.out.println("Using SQL database");
            loader = new Qloader(user.getSkill(), user.getSQLData());
        } else {
            //System.out.println("Using text database");
            loader = new Qloader(user.getSkill(), user.getDataFile());
        }
        ok = loader.enoughQz(user.getNumOfQuestions());
    }
    
    public void go(){
        if(ok){
        user.getGUI().getQDisplay().setSysText(" ");
        Thread timeThread = new Thread(new clockE(user));
        timeThread.setPriority(3);
        timeThread.start();
        Thread testThread = new Thread(new Asker(user, loader));
        testThread.setPriority(6);
        testThread.start();
        } else {
            user.getGUI().hideTab(1, false, 2);
            user.getGUI().getLogDisplay().setResults("\n" +
            "ERROR:\n" +
            "  The database you have selected contains\n" +
            "insuffient questions of the type you have\n" +
            "selected.  Please return to the the Setup\n" +
            "tab and try again.\n" +
            "  If you're having trouble,  when not try\n" +
            "using the  default database?  It contains\n" +
            "many challenging  questions at all levels\n" +
            "of difficulty.");
        }
        buttons = user.getGUI().getLogDisplay().getButtons();
        buttons[0].setActionCommand("0");buttons[0].addActionListener(this);
        buttons[1].setActionCommand("1");buttons[1].addActionListener(this);
    }
    
    public void actionPerformed(ActionEvent e){
        switch(Integer.parseInt(e.getActionCommand())){
            case 0:
                //try again
                buttons[0].removeActionListener(this); buttons[1].removeActionListener(this);
                user.getGUI().hideTab(2, false, 0);
                break;
            case 1:
                System.exit(0);
        }
    }
}