package JavaProject.Test;

import JavaProject.Qeditor.Question;
import JavaProject.Gui.appGui;
import java.io.File;

public class User{
    
    /*****************************************************
     * The User object stores all the various variables  *
     * that are used throughout the life of the program. *
     * To avoid ISSUES it is a singleton design.         *
     *****************************************************/
    
    private static User instance = new User();
    private String name, results;
    private int skill, numOfQuestions, numCorrect, numAnswered;
    private boolean getAnswers;
    private appGui GUI;
    private boolean end, bail;
    private int seconds;
    private StringBuffer testLog;
    private String[] SQLData;
    private File dataFile;
    
    private User(){defaultValues();}

    public void reset(){
        GUI.getADisplay().setMode("default");
        defaultValues();
        setValues(" ",0,0,false, new File("default"), new String[]{"", "", "", "0"});
    }
    
    private void defaultValues(){
        seconds = 0; numCorrect = 0; numAnswered = 0;
        end = false;
        bail = false;
        testLog = new StringBuffer("EXAM LOG\n\n");
    }
        
    public void setValues(String name, int skill, int questions, boolean answers, File file, String[] SQLData){
        this.name = name;
        this.skill = skill;
        numOfQuestions = questions;
        getAnswers = answers;
        dataFile = file;
        this.SQLData = SQLData;
    }
    
    public static User getUser(){return instance;}
    public String getName(){return name;}
    public int getSkill(){return skill;}
    public int getNumOfQuestions(){return numOfQuestions;}
    public int getNumAnswered(){return numAnswered;}
    public int getNumCorrect(){return numCorrect;}
    public appGui getGUI(){return GUI;}
    public String[] getSQLData(){return SQLData;}
    public File getDataFile(){return dataFile;}
    public int getFileMode(){return Integer.parseInt(SQLData[3]);}
    public boolean getEnd(){return end;}
    

    public String getResults(){
        String temp = name;
        String time = (seconds/60) + " minutes and " + (seconds%60) + " seconds.\n";
        if(bail){
            temp += " limped off the field after only " + time;
        } else {temp += " completed the test in " + time;}
        float i = ((float)numCorrect / (float)numOfQuestions) * 100;
        temp += "\nFINAL SCORE:\t" + (int)i + "% (" + numCorrect + " out of " + numOfQuestions + ")\n";
        if (getAnswers) return temp + testLog.toString(); 
        else return temp;
    }
    
    public void setEnd(){end = true;}
    public void setGui(appGui GUI){this.GUI = GUI;}
    public void nextSecond(){seconds++;}
    
    public void updateLog(Question q, boolean right){
        numAnswered++; addToLog(q);
        if(right){
            numCorrect++;
            testLog.append("<<You got this one right.>>\n\n");
        } else {
            testLog.append("<<You got this one wrong.>>\n");
            if(q.getDifficulty()>2){
                testLog.append("Your answer: " + GUI.getADisplay().getInpAnswer());
            }
            testLog.append("\n\n");
        }
    }
    
    public void addToLog(Question q){
        testLog.append("QUESTION #" + numAnswered + ": "+ q.getQuestion() + "\n\n");
        String answers[] = q.getAnswers();
        if (q.getDifficulty()<3){
            testLog.append("ANSWER(s):\n");
            boolean valid[] = q.getValidity();
            for (int i = 0; i < 4; i++){
                if(valid[i]){
                    testLog.append(answers[i] + "\n");
                }
            }
        } else if (q.getDifficulty()>2){
            testLog.append("ANSWER(s):\n" + answers[0] + "\n");
        }
    }
   
    public void bailOut(){bail = true;}
        
}